# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Use lightweight ExtUtils::MM::Utils in preference to ExtUtils::MakeMaker where possible
%if 0%{?fedora} > 22 || 0%{?rhel} > 7
%global use_mm_utils 1
%endif

Name:		perl-IPC-Cmd
Epoch:		2
Version:	1.04
Release:	1.%{__distinit}%{__distvers}
Summary:	Finding and running system commands made easy
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/IPC-Cmd
Source0:	https://cpan.metacpan.org/modules/by-module/IPC/IPC-Cmd-%{version}.tar.gz
Patch0:		IPC-Cmd-0.96-Replace-EU-MM-dependency-with-EU-MM-Utils.patch
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
%if 0%{?use_mm_utils}
BuildRequires:	perl(ExtUtils::MM::Utils)
%endif
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(FileHandle)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IO::Select)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(IPC::Run) >= 0.55
BuildRequires:	perl(Locale::Maketext::Simple)
BuildRequires:	perl(Module::Load::Conditional) >= 0.66
BuildRequires:	perl(Params::Check) >= 0.20
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Socket)
BuildRequires:	perl(strict)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Text::ParseWords)
BuildRequires:	perl(Time::HiRes)
BuildRequires:	perl(vars)
# Test Suite
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(warnings)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%if 0%{?use_mm_utils}
Requires:	perl(ExtUtils::MM::Utils)
%else
Requires:	perl(ExtUtils::MakeMaker)
%endif
Requires:	perl(FileHandle)
Requires:	perl(IO::Handle)
Requires:	perl(IO::Select)
Requires:	perl(IPC::Open3)
Requires:	perl(IPC::Run) >= 0.55
Requires:	perl(Module::Load::Conditional) >= 0.66
Requires:	perl(POSIX)
Requires:	perl(Socket)
Requires:	perl(Time::HiRes)

# Drop under-specified dependency
%global __requires_exclude ^perl\\(Module::Load::Conditional\\)$

%description
IPC::Cmd allows you to run commands, interactively if desired, platform
independent but have them still work.

%prep
%setup -q -n IPC-Cmd-%{version}

# Replace ExtUtils::MakeMaker dependency with ExtUtils::MM::Utils
# This avoids pulling in perl-devel (#1129443)
%if 0%{?use_mm_utils}
%patch0 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc CHANGES README
%{perl_vendorlib}/IPC/
%{_mandir}/man3/IPC::Cmd.3*

%changelog
* Mon Jul 15 2019 Paul Howarth <paul@city-fan.org> - 2:1.04-1
- Update to 1.04
  - Fixed usage of setsid() (GH#21)

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 2:1.02-2
- Perl 5.28 rebuild

* Thu May  3 2018 Paul Howarth <paul@city-fan.org> - 2:1.02-1
- Update to 1.02
  - Fix use of IPC::Cmd->run_forked in the first process of a container
    (CPAN RT#118424)
  - Make fix for CPAN RT#91784 only apply to HPUX

* Wed Feb 14 2018 Paul Howarth <paul@city-fan.org> - 2:1.00-1
- Update to 1.00
  - run_forked("/usr/bin/echo test") captured no output (CPAN RT#91784)
  - The 03_run_forked.t test sometimes failed on HPUX (CPAN RT#124415)
- Bump epoch to 2 to compete with perl.spec

* Sun May 14 2017 Paul Howarth <paul@city-fan.org> - 1:0.98-1
- Update to 0.98
  - Added wait_loop_callback for run_forked()
  - Only search in curdir in can_run() when on Win32 (CPAN RT#105601)
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Thu Jul 28 2016 Paul Howarth <paul@city-fan.org> - 1:0.96-1
- Update to 0.96
  - Require Module::Load::Conditional 0.66 to resolve CVE-2016-1238
    (avoid loading optional modules from default .)
- Update patch for use of ExtUtils::MM::Utils

* Fri May 20 2016 Paul Howarth <paul@city-fan.org> - 1:0.94-5
- BR: perl-generators where possible
- ExtUtils::MM::Utils now available from F-23 onwards

* Wed Apr 27 2016 Paul Howarth <paul@city-fan.org> - 1:0.94-4
- Rebuild - forgot to sign previous build

* Tue Apr 26 2016 Paul Howarth <paul@city-fan.org> - 1:0.94-3
- Use lightweight ExtUtils::MM::Utils in preference to ExtUtils::MakeMaker
  where possible (#1129443)
- Simplify find command using -delete

* Sat Feb 13 2016 Paul Howarth <paul@city-fan.org> - 1:0.94-1
- Update to 0.94
  - Move __END__ above POD in documentation
  - Don't clobber $SIG{__DIE__} and $SIG{__WARN__} in open3_run()
  - Fix 'terminate_on_signal' segfaulting
  - Fix usage of fcntl(..., F_GETFL, ...)
- Classify buildreqs by usage

* Tue Sep  2 2014 Paul Howarth <paul@city-fan.org> - 1:0.92-3
- Drop %%defattr, redundant since rpm 4.4

* Thu Jan 23 2014 Paul Howarth <paul@city-fan.org> - 1:0.92-2
- Bump epoch to 1 to compete with perl.spec

* Thu Jan 23 2014 Paul Howarth <paul@city-fan.org> - 0.92-1
- Update to 0.92
  - Use File::Temp in run_forked tests

* Mon Nov 18 2013 Paul Howarth <paul@city-fan.org> - 0.90-1
- Update to 0.90
  - Skip some problematic tests when PERL_CORE

* Fri Nov 15 2013 Paul Howarth <paul@city-fan.org> - 0.88-1
- Update to 0.88
  - Skip some problematic tests on Cygwin

* Mon Nov  4 2013 Paul Howarth <paul@city-fan.org> - 0.86-1
- Update to 0.86
  - run_forked() now uses Time::HiRes and Carp
  - Fix incomplete output more than buffer size in run_forked
  - Work around absent CLOCK_MONOTONIC on OSX in run_forked
  - Fix error reporting if command killed by signal (CPAN RT#89770)
  - Make the false test more forgiving, for Solaris and other SVR*

* Tue Aug  6 2013 Paul Howarth <paul@city-fan.org> - 0.84-1
- Update to 0.84
  - Lowered CPU usage for run_forked()
  - Handle STDOUT/STDERR for run_forked() and coderefs (CPAN RT#85912)
  - Fixed regression introduced in 0.78 (CPAN RT#76901)
  - run_forked() now has a consistent API with run() (CPAN RT#70530)
  - Socket only used where needed
  - Install into sitelib by default if Perl ≥ v5.12.0

* Thu Jul 18 2013 Paul Howarth <paul@city-fan.org> - 0.82-2
- Perl 5.18 rebuild

* Sun Jun 30 2013 Paul Howarth <paul@city-fan.org> - 0.82-1
- Update to 0.82
  - Typo fixes

* Sun Mar  3 2013 Paul Howarth <paul@city-fan.org> - 0.80-1
- Update to 0.80
  - Use File::Spec->path instead of relying on Config

* Tue Jul  3 2012 Paul Howarth <paul@city-fan.org> - 0.78-2
- BR:/R: perl(IO::Handle), perl(IO::Select) and perl(Time::HiRes)
- BR: perl(lib)

* Tue May  1 2012 Paul Howarth <paul@city-fan.org> - 0.78-1
- Update to 0.78
  - Use POSIX::_exit() instead of exit() in run_forked() (CPAN RT#76901)
- Don't need to remove empty directories from buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Mon Jan 30 2012 Paul Howarth <paul@city-fan.org> - 0.76-1
- Update to 0.76
   - Make the empty arg stripping the default again, with an option to
     override this behaviour

* Mon Jan 30 2012 Paul Howarth <paul@city-fan.org> - 0.74-1
- Update to 0.74
  - CPAN RT#74373: Compilation error when POSIX.pm fails to load
  - CPAN RT#74470: Empty string cannot be passed to command
- Add buildreqs for perl core modules that might be dual-lived

* Mon Oct 31 2011 Paul Howarth <paul@city-fan.org> - 0.72-3
- Require perl(ExtUtils::MakeMaker) (#711486)

* Mon Jun 27 2011 Paul Howarth <paul@city-fan.org> - 0.72-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jun 22 2011 Paul Howarth <paul@city-fan.org> - 0.72-1
- Update to 0.72
  - Added IPC::Open3 support for capturing STDOUT/STDERR on MSWin32; prefer
    this over IPC::Run
- Nobody else likes macros for commands

* Tue Feb  1 2011 Paul Howarth <paul@city-fan.org> - 0.70-1
- Update to 0.70
  - Apply a patch from CPAN RT #65276 with changes for run_forked:
    - Fix for the typo in the name of the signal
    - Changed default for clean_up_children (which seems to be the behaviour
      expected by the majority of the users)
    - Added detection (and forwarding to the caller) of the case when run
      program is killed by signal
    - kill_gently is now used in cases when parent died and when the executed
      program times out
    - Added options that allow execution of some user code in the beginning and
      at the end of the child process

* Mon Jan 10 2011 Paul Howarth <paul@city-fan.org> - 0.68-1
- Update to 0.68 (fixes for bleadperl)

* Wed Dec  8 2010 Paul Howarth <paul@city-fan.org> - 0.66-1
- Import from Fedora
- Update to 0.66
- This release by BINGOS -> update source URL

* Mon Oct 15 2007 Steven Pritchard <steve@kspei.com> - 0.38-1
- Update to 0.38
- Update License tag
- BR Test::More

* Wed Apr 18 2007 Steven Pritchard <steve@kspei.com> - 0.36-2
- BR ExtUtils::MakeMaker

* Fri Nov 24 2006 Steven Pritchard <steve@kspei.com> - 0.36-1
- Update to 0.36

* Fri Nov 03 2006 Steven Pritchard <steve@kspei.com> - 0.34-1
- Update to 0.34
- Explicitly BR Params::Check >= 0.20

* Tue Oct 17 2006 Steven Pritchard <steve@kspei.com> - 0.32-1
- Update to 0.32
- Use fixperms macro instead of our own chmod incantation

* Sat Sep 16 2006 Steven Pritchard <steve@kspei.com> - 0.25-1
- Update to 0.25
- Fix find option order

* Thu Mar 23 2006 Steven Pritchard <steve@kspei.com> - 0.24-1
- Specfile autogenerated by cpanspec 1.62
- Fix License
- Drop explicit Requires
